using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic {
public class BluemagicInterface : ModInterface
{
    public override bool PreDrawTooltipItem(SpriteBatch sb, Item item, ref string text, ref int rare)
    {
        if(Main.toolTip.rare <= 9)
        {
            return true;
        }
        Main.localPlayer.showItemIcon = false;
        if (API.main.mouseNPC < 0 && text != null)
        {
            int num = Main.mouseX + 10;
            int num2 = Main.mouseY + 10;
            Color color = new Color((int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor);
            float num18;
            int itemRare = Main.toolTip.rare;
            float arg_61_0 = Main.toolTip.knockBack;
            float num3 = 1f;
            if (Main.toolTip.melee && Main.localPlayer.knockbackMeleeModVanilla != 1f)
            {
                num3 *= Main.localPlayer.knockbackMeleeModVanilla;
            }
            if (Main.localPlayer.knockbackMod != 1f)
            {
                num3 *= Main.localPlayer.knockbackMod;
            }
            if (num3 != 1f)
            {
                Main.toolTip.knockBack *= num3;
            }
            if (Main.toolTip.ranged && Main.localPlayer.armorStealth)
            {
                Main.toolTip.knockBack *= 1f + (1f - Main.localPlayer.stealth) * 0.5f;
            }
            int num4 = 20;
            int num5 = 1;
            string[] array = new string[num4];
            bool[] array2 = new bool[num4];
            bool[] array3 = new bool[num4];
            for (int i = 0; i < num4; i++)
            {
                array2[i] = false;
                array3[i] = false;
            }
            array[0] = Main.toolTip.AffixName();
            if (Main.toolTip.stack > 1)
            {
                string[] array5;
                string[] array4 = array5 = array;
                int num6 = 0;
                object obj = array4[0];
                array5[num6] = string.Concat(new object[]
                {
                    obj,
                    " (",
                    Main.toolTip.stack,
                    ")"
                });
            }
            if (Main.toolTip.social)
            {
                array[num5] = Lang.tip[0];
                num5++;
                array[num5] = Lang.tip[1];
                num5++;
            }
            else
            {
                if (Main.toolTip.damage > 0 && !Main.toolTip.notAmmo)
                {
                    float num7 = 5E-06f;
                    int damage = Main.toolTip.damage;
                    if (Main.toolTip.melee)
                    {
                        array[num5] = string.Concat((int)(Main.localPlayer.meleeDamage * (float)damage + num7));
                        System.IntPtr value = (System.IntPtr)num5;
                        string[] array6 = array;
                        array6[(int)value] = array6[(int)value] + Lang.tip[2];
                    }
                    else if (Main.toolTip.ranged)
                    {
                        float num8 = (float)damage * Main.localPlayer.rangedDamage;
                        if (Main.toolTip.useAmmo == 1 || Main.toolTip.useAmmo == 323)
                        {
                            num8 *= Main.localPlayer.arrowDamage;
                        }
                        if (Main.toolTip.useAmmo == 1 && Main.localPlayer.archery)
                        {
                            num8 *= 1.2f;
                        }
                        if (Main.toolTip.useAmmo == 14 || Main.toolTip.useAmmo == 311)
                        {
                            num8 *= Main.localPlayer.bulletDamage;
                        }
                        if (Main.toolTip.useAmmo == 771 || Main.toolTip.useAmmo == 246 || Main.toolTip.useAmmo == 312)
                        {
                            num8 *= Main.localPlayer.rocketDamage;
                        }
                        array[num5] = string.Concat((int)(num8 + num7));
                        System.IntPtr value2 = (System.IntPtr)num5;
                        string[] array7 = array;
                        array7[(int)value2] = array7[(int)value2] + Lang.tip[3];
                    }
                    else if (Main.toolTip.magic)
                    {
                        array[num5] = string.Concat((int)(Main.localPlayer.magicDamage * (float)damage + num7));
                        System.IntPtr value3 = (System.IntPtr)num5;
                        string[] array8 = array;
                        array8[(int)value3] = array8[(int)value3] + Lang.tip[4];
                    }
                    else if (Main.toolTip.summon)
                    {
                        array[num5] = string.Concat((int)(Main.localPlayer.minionDamage * (float)damage + num7));
                        System.IntPtr value4 = (System.IntPtr)num5;
                        string[] array9 = array;
                        array[(int)value4] = array9[(int)value4] + Lang.tip[53];
                    }
                    else
                    {
                        array[num5] = string.Concat(damage);
                        System.IntPtr value5 = (System.IntPtr)num5;
                        string[] array10 = array;
                        array10[(int)value5] = array10[(int)value5] + Lang.tip[55];
                    }
                    num5++;
                    if (Main.toolTip.melee)
                    {
                        int num9 = Main.localPlayer.meleeCrit - Main.localPlayer.inventory[Main.localPlayer.selectedItem].crit + Main.toolTip.crit;
                        if (num9 < 0)
                        {
                            num9 = 0;
                        }
                        array[num5] = num9 + Lang.tip[5];
                        num5++;
                    }
                    else if (Main.toolTip.ranged)
                    {
                        int num10 = Main.localPlayer.rangedCrit - Main.localPlayer.inventory[Main.localPlayer.selectedItem].crit + Main.toolTip.crit;
                        if (num10 < 0)
                        {
                            num10 = 0;
                        }
                        array[num5] = num10 + Lang.tip[5];
                        num5++;
                    }
                    else if (Main.toolTip.magic)
                    {
                        int num11 = Main.localPlayer.magicCrit - Main.localPlayer.inventory[Main.localPlayer.selectedItem].crit + Main.toolTip.crit;
                        if (num11 < 0)
                        {
                            num11 = 0;
                        }
                        array[num5] = num11 + Lang.tip[5];
                        num5++;
                    }
                    if (Main.toolTip.useStyle > 0 && !Main.toolTip.summon)
                    {
                        if (Main.toolTip.useAnimation <= 8)
                        {
                            array[num5] = Lang.tip[6];
                        }
                        else if (Main.toolTip.useAnimation <= 20)
                        {
                            array[num5] = Lang.tip[7];
                        }
                        else if (Main.toolTip.useAnimation <= 25)
                        {
                            array[num5] = Lang.tip[8];
                        }
                        else if (Main.toolTip.useAnimation <= 30)
                        {
                            array[num5] = Lang.tip[9];
                        }
                        else if (Main.toolTip.useAnimation <= 35)
                        {
                            array[num5] = Lang.tip[10];
                        }
                        else if (Main.toolTip.useAnimation <= 45)
                        {
                            array[num5] = Lang.tip[11];
                        }
                        else if (Main.toolTip.useAnimation <= 55)
                        {
                            array[num5] = Lang.tip[12];
                        }
                        else
                        {
                            array[num5] = Lang.tip[13];
                        }
                        num5++;
                    }
                    float num12 = Main.toolTip.knockBack;
                    if (Main.toolTip.summon)
                    {
                        num12 += Main.localPlayer.minionKB;
                    }
                    if ((Main.localPlayer.magicQuiver && Main.toolTip.useAmmo == 1) || Main.toolTip.useAmmo == 323)
                    {
                        num12 = (float)((int)(num12 * 1.1f));
                    }
                    if (num12 == 0f)
                    {
                        array[num5] = Lang.tip[14];
                    }
                    else if ((double)num12 <= 1.5)
                    {
                        array[num5] = Lang.tip[15];
                    }
                    else if (num12 <= 3f)
                    {
                        array[num5] = Lang.tip[16];
                    }
                    else if (num12 <= 4f)
                    {
                        array[num5] = Lang.tip[17];
                    }
                    else if (num12 <= 6f)
                    {
                        array[num5] = Lang.tip[18];
                    }
                    else if (num12 <= 7f)
                    {
                        array[num5] = Lang.tip[19];
                    }
                    else if (num12 <= 9f)
                    {
                        array[num5] = Lang.tip[20];
                    }
                    else if (num12 <= 11f)
                    {
                        array[num5] = Lang.tip[21];
                    }
                    else
                    {
                        array[num5] = Lang.tip[22];
                    }
                    num5++;
                }
                if (Main.toolTip.fishingPole > 0)
                {
                    array[num5] = Main.toolTip.fishingPole + "% fishing power";
                    num5++;
                    array[num5] = "Requires bait to catch fish";
                    num5++;
                }
                if (Main.toolTip.bait > 0)
                {
                    array[num5] = Main.toolTip.bait + "% bait power";
                    num5++;
                }
                if (Main.toolTip.headSlot > 0 || Main.toolTip.bodySlot > 0 || Main.toolTip.legSlot > 0 || Main.toolTip.accessory)
                {
                    array[num5] = Lang.tip[23];
                    num5++;
                }
                if (Main.toolTip.tileWand > 0)
                {
                    array[num5] = Lang.tip[52] + Lang.itemName(Main.toolTip.tileWand, false);
                    num5++;
                }
                if (Main.toolTip.questItem)
                {
                    array[num5] = Lang.inter[65];
                    num5++;
                }
                if (Main.toolTip.vanity)
                {
                    array[num5] = Lang.tip[24];
                    num5++;
                }
                if (Main.toolTip.defense > 0)
                {
                    array[num5] = Main.toolTip.defense + Lang.tip[25];
                    num5++;
                }
                if (Main.toolTip.pick > 0)
                {
                    array[num5] = Main.toolTip.pick + Lang.tip[26];
                    num5++;
                }
                if (Main.toolTip.axe > 0)
                {
                    array[num5] = Main.toolTip.axe * 5 + Lang.tip[27];
                    num5++;
                }
                if (Main.toolTip.hammer > 0)
                {
                    array[num5] = Main.toolTip.hammer + Lang.tip[28];
                    num5++;
                }
                if (Main.toolTip.tileBoost != 0)
                {
                    int tileBoost = Main.toolTip.tileBoost;
                    if (tileBoost > 0)
                    {
                        array[num5] = "+" + tileBoost + Lang.tip[54];
                    }
                    else
                    {
                        array[num5] = tileBoost + Lang.tip[54];
                    }
                    num5++;
                }
                if (Main.toolTip.healLife > 0)
                {
                    array[num5] = string.Concat(new object[]
                    {
                        Lang.tip[29],
                        " ",
                        Main.toolTip.healLife,
                        " ",
                        Lang.tip[30]
                    });
                    num5++;
                }
                if (Main.toolTip.healMana > 0)
                {
                    array[num5] = string.Concat(new object[]
                    {
                        Lang.tip[29],
                        " ",
                        Main.toolTip.healMana,
                        " ",
                        Lang.tip[31]
                    });
                    num5++;
                }
                if (Main.toolTip.mana > 0 && (Main.toolTip.type != 127 || !Main.localPlayer.spaceGun))
                {
                    array[num5] = string.Concat(new object[]
                    {
                        Lang.tip[32],
                        " ",
                        (int)((float)Main.toolTip.mana * Main.localPlayer.manaCost),
                        " ",
                        Lang.tip[31]
                    });
                    num5++;
                }
                if (Main.toolTip.createWall > 0 || Main.toolTip.createTile > -1)
                {
                    if (Main.toolTip.type != 213 && Main.toolTip.type != 832)
                    {
                        array[num5] = Lang.tip[33];
                        num5++;
                    }
                }
                else
                {
                    if (Main.toolTip.ammo > 0 && !Main.toolTip.notAmmo)
                    {
                        array[num5] = Lang.tip[34];
                        num5++;
                    }
                    else
                    {
                        if (Main.toolTip.consumable)
                        {
                            array[num5] = Lang.tip[35];
                            num5++;
                        }
                    }
                }
                if (Main.toolTip.material && !Main.toolTip.notMaterial)
                {
                    array[num5] = Lang.tip[36];
                    num5++;
                }
                System.Collections.Generic.List<string> list = new System.Collections.Generic.List<string>();
                for (int j = 0; j < array.Length; j++)
                {
                    if (!string.IsNullOrEmpty(array[j]))
                    {
                        list.Add(array[j]);
                    }
                }
                for (int k = 0; k < Main.toolTip.tooltips.Count; k++)
                {
                    if (!string.IsNullOrEmpty(Main.toolTip.tooltips[k]))
                    {
                        list.Add(Main.toolTip.tooltips[k]);
                    }
                }
                if (Main.toolTip.modEntities.Count > 0)
                {
                    Main.toolTip.ModifyToolTip(Main.localPlayer, list);
                }
                string[] array11 = list.ToArray();
                num5 = 0;
                for (int l = 0; l < array11.Length; l++)
                {
                    if (!string.IsNullOrEmpty(array11[l]))
                    {
                        array[num5] = array11[l];
                        num5++;
                    }
                }
                if (Main.toolTip.buffTime > 0)
                {
                    string text0;
                    if (Main.toolTip.buffTime / 60 >= 60)
                    {
                        text0 = System.Math.Round((double)(Main.toolTip.buffTime / 60) / 60.0) + Lang.tip[37];
                    }
                    else
                    {
                        text0 = System.Math.Round((double)Main.toolTip.buffTime / 60.0) + Lang.tip[38];
                    }
                    array[num5] = text;
                    num5++;
                }
                Tuple<string, bool>[] array12 = Main.toolTip.prefix.TooltipText(Main.toolTip);
                for (int m = 0; m < array12.Length; m++)
                {
                    Tuple<string, bool> tuple = array12[m];
                    array[num5] = tuple.Item1;
                    array2[num5] = true;
                    array3[num5++] = !tuple.Item2;
                }
                if (Main.toolTip.wornArmor && Main.localPlayer.setBonus != "")
                {
                    array[num5] = Lang.tip[48] + " " + Main.localPlayer.setBonus;
                    num5++;
                }
            }
            if (Main.npcShop > 0)
            {
                if (Main.toolTip.value > 0)
                {
                    string text2 = "";
                    int num13 = 0;
                    int num14 = 0;
                    int num15 = 0;
                    int num16 = 0;
                    int num17 = Main.toolTip.value * Main.toolTip.stack;
                    if (!Main.toolTip.buy)
                    {
                        num17 = Main.toolTip.value / 5 * Main.toolTip.stack;
                    }
                    if (num17 < 1)
                    {
                        num17 = 1;
                    }
                    if (num17 >= 1000000)
                    {
                        num13 = num17 / 1000000;
                        num17 -= num13 * 1000000;
                    }
                    if (num17 >= 10000)
                    {
                        num14 = num17 / 10000;
                        num17 -= num14 * 10000;
                    }
                    if (num17 >= 100)
                    {
                        num15 = num17 / 100;
                        num17 -= num15 * 100;
                    }
                    if (num17 >= 1)
                    {
                        num16 = num17;
                    }
                    if (num13 > 0)
                    {
                        object obj2 = text2;
                        text2 = string.Concat(new object[]
                        {
                            obj2,
                            num13,
                            " ",
                            Lang.inter[15],
                            " "
                        });
                    }
                    if (num14 > 0)
                    {
                        object obj3 = text2;
                        text2 = string.Concat(new object[]
                        {
                            obj3,
                            num14,
                            " ",
                            Lang.inter[16],
                            " "
                        });
                    }
                    if (num15 > 0)
                    {
                        object obj4 = text2;
                        text2 = string.Concat(new object[]
                        {
                            obj4,
                            num15,
                            " ",
                            Lang.inter[17],
                            " "
                        });
                    }
                    if (num16 > 0)
                    {
                        object obj5 = text2;
                        text2 = string.Concat(new object[]
                        {
                            obj5,
                            num16,
                            " ",
                            Lang.inter[18],
                            " "
                        });
                    }
                    if (!Main.toolTip.buy)
                    {
                        array[num5] = Lang.tip[49] + " " + text2;
                    }
                    else
                    {
                        array[num5] = Lang.tip[50] + " " + text2;
                    }
                    num5++;
                    num18 = (float)Main.mouseTextColor / 255f;
                    if (num13 > 0)
                    {
                        color = new Color((int)((byte)(220f * num18)), (int)((byte)(220f * num18)), (int)((byte)(198f * num18)), (int)Main.mouseTextColor);
                    }
                    else if (num14 > 0)
                    {
                        color = new Color((int)((byte)(224f * num18)), (int)((byte)(201f * num18)), (int)((byte)(92f * num18)), (int)Main.mouseTextColor);
                    }
                    else if (num15 > 0)
                    {
                        color = new Color((int)((byte)(181f * num18)), (int)((byte)(192f * num18)), (int)((byte)(193f * num18)), (int)Main.mouseTextColor);
                    }
                    else if (num16 > 0)
                    {
                        color = new Color((int)((byte)(246f * num18)), (int)((byte)(138f * num18)), (int)((byte)(96f * num18)), (int)Main.mouseTextColor);
                    }
                }
                else
                {
                    num18 = (float)Main.mouseTextColor / 255f;
                    array[num5] = Lang.tip[51];
                    num5++;
                    color = new Color((int)((byte)(120f * num18)), (int)((byte)(120f * num18)), (int)((byte)(120f * num18)), (int)Main.mouseTextColor);
                }
            }
            Vector2 zero = Vector2.Zero;
            int num19 = 0;
            for (int n = 0; n < num5; n++)
            {
                Vector2 vector = Main.fontMouseText.MeasureString(array[n]);
                if (vector.X > zero.X)
                {
                    zero.X = vector.X;
                }
                zero.Y += vector.Y + (float)num19;
            }
            if ((float)num + zero.X + 4f > (float)Main.screenWidth)
            {
                num = (int)((float)Main.screenWidth - zero.X - 4f);
            }
            if ((float)num2 + zero.Y + 4f > (float)Main.screenHeight)
            {
                num2 = (int)((float)Main.screenHeight - zero.Y - 4f);
            }
            int num20 = 0;
            num18 = (float)Main.mouseTextColor / 255f;
            for (int num21 = 0; num21 < num5; num21++)
            {
                for (int num22 = 0; num22 < 5; num22++)
                {
                    int num23 = num;
                    int num24 = num2 + num20;
                    Color color2 = Color.Black;
                    if (num22 == 0)
                    {
                        num23 -= 2;
                    }
                    else if (num22 == 1)
                    {
                        num23 += 2;
                    }
                    else if (num22 == 2)
                    {
                        num24 -= 2;
                    }
                    else if (num22 == 3)
                    {
                        num24 += 2;
                    }
                    else
                    {
                        color2 = new Color((int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor);
                        if (num21 == 0)
                        {
                            if (itemRare == 10)
                            {
                                color2 = new Color((int)((byte)(255f * num18)), (int)((byte)(10f * num18)), (int)((byte)(10f * num18)), (int)Main.mouseTextColor);
                            }
                            if (itemRare == 11)
                            {
                                color2 = new Color((int)((byte)(255f * num18)), (int)((byte)(10f * num18)), (int)((byte)(255f * num18)), (int)Main.mouseTextColor);
                            }
                            if (itemRare == 12)
                            {
                                color2 = new Color((int)((byte)(Bluemagic.PureColor.R * num18)), (int)((byte)(Bluemagic.PureColor.G * num18)), (int)((byte)(Bluemagic.PureColor.B * num18)), (int)Main.mouseTextColor);
                            }
                            if (itemRare >= 13)
                            {
                                color2 = new Color((int)((byte)(Main.DiscoR * num18)), (int)((byte)(Main.DiscoG * num18)), (int)((byte)(Main.DiscoB * num18)), (int)Main.mouseTextColor);
                            }
                        }
                        else if (array2[num21])
                        {
                            if (array3[num21])
                            {
                                color2 = new Color((int)((byte)(190f * num18)), (int)((byte)(120f * num18)), (int)((byte)(120f * num18)), (int)Main.mouseTextColor);
                            }
                            else
                            {
                                color2 = new Color((int)((byte)(120f * num18)), (int)((byte)(190f * num18)), (int)((byte)(120f * num18)), (int)Main.mouseTextColor);
                            }
                        }
                        else if (num21 == num5 - 1)
                        {
                            color2 = color;
                        }
                    }
                    Main.spriteBatch.DrawString(Main.fontMouseText, array[num21], new Vector2((float)num23, (float)num24), color2, 0f, default(Vector2), 1f, SpriteEffects.None, 0f);
                }
                num20 += (int)(Main.fontMouseText.MeasureString(array[num21]).Y + (float)num19);
            }
        }
        Main.mouseText = true;
        return false;
    }

    public override bool PreDrawTooltipText(SpriteBatch sb, string context, ref string text, ref int rare)
    {
        if(!context.Equals("Vanilla:Generic") || rare <= 9)
        {
            return true;
        }
        Main.localPlayer.showItemIcon = false;
        if(API.main.mouseNPC < 0 && text != null)
        {
            int num = Main.mouseX + 10;
            int num2 = Main.mouseY + 10;
            Color color = new Color((int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor);
            float num18;
            if (Main.buffString != "" && Main.buffString != null)
            {
                for (int num25 = 0; num25 < 5; num25++)
                {
                    int num26 = num;
                    int num27 = num2 + (int)Main.fontMouseText.MeasureString(Main.buffString).Y;
                    Color black = Color.Black;
                    if (num25 == 0)
                    {
                        num26 -= 2;
                    }
                    else if (num25 == 1)
                    {
                        num26 += 2;
                    }
                    else if (num25 == 2)
                    {
                        num27 -= 2;
                    }
                    else if (num25 == 3)
                    {
                        num27 += 2;
                    }
                    else
                    {
                        black = new Color((int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor);
                    }
                    Main.spriteBatch.DrawString(Main.fontMouseText, Main.buffString, new Vector2((float)num26, (float)num27), black, 0f, default(Vector2), 1f, SpriteEffects.None, 0f);
                }
            }
            Vector2 vector2 = Main.fontMouseText.MeasureString(text);
            if ((float)num + vector2.X + 4f > (float)Main.screenWidth)
            {
                num = (int)((float)Main.screenWidth - vector2.X - 4f);
            }
            if ((float)num2 + vector2.Y + 4f > (float)Main.screenHeight)
            {
                num2 = (int)((float)Main.screenHeight - vector2.Y - 4f);
            }
            Main.spriteBatch.DrawString(Main.fontMouseText, text, new Vector2((float)num, (float)(num2 - 2)), Color.Black, 0f, default(Vector2), 1f, SpriteEffects.None, 0f);
            Main.spriteBatch.DrawString(Main.fontMouseText, text, new Vector2((float)num, (float)(num2 + 2)), Color.Black, 0f, default(Vector2), 1f, SpriteEffects.None, 0f);
            Main.spriteBatch.DrawString(Main.fontMouseText, text, new Vector2((float)(num - 2), (float)num2), Color.Black, 0f, default(Vector2), 1f, SpriteEffects.None, 0f);
            Main.spriteBatch.DrawString(Main.fontMouseText, text, new Vector2((float)(num + 2), (float)num2), Color.Black, 0f, default(Vector2), 1f, SpriteEffects.None, 0f);
            num18 = (float)Main.mouseTextColor / 255f;
            Color color3 = new Color((int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor, (int)Main.mouseTextColor);
            if (rare == 10)
            {
                color3 = new Color((int)((byte)(255f * num18)), (int)((byte)(10f * num18)), (int)((byte)(10f * num18)), (int)Main.mouseTextColor);
            }
            if (rare == 11)
            {
                color3 = new Color((int)((byte)(255f * num18)), (int)((byte)(10f * num18)), (int)((byte)(255f * num18)), (int)Main.mouseTextColor);
            }
            if (rare == 12)
            {
                color3 = new Color((int)((byte)(Bluemagic.PureColor.R * num18)), (int)((byte)(Bluemagic.PureColor.G * num18)), (int)((byte)(Bluemagic.PureColor.B * num18)), (int)Main.mouseTextColor);
            }
            if (rare >= 13)
            {
                color3 = new Color((int)((byte)(Main.DiscoR * num18)), (int)((byte)(Main.DiscoG * num18)), (int)((byte)(Main.DiscoB * num18)), (int)Main.mouseTextColor);
            }
            Main.spriteBatch.DrawString(Main.fontMouseText, text, new Vector2((float)num, (float)num2), color3, 0f, default(Vector2), 1f, SpriteEffects.None, 0f);
        }
        Main.mouseText = true;
        return false;
    }

    public override bool PreDrawTooltipItemInWorld(SpriteBatch sb, Item item, ref string text, ref int rare)
    {
        return PreDrawTooltipText(sb, "Vanilla:Generic", ref text, ref rare);
    }

    public override void OnItemTextSpawn(ItemText itemtext, Item item)
    {
        if(item.rare == 10)
        {
            itemtext.color = new Color(255, 10, 10);
        }
        if(item.rare == 11)
        {
            itemtext.color = new Color(255, 10, 255);
        }
        if(item.rare == 12)
        {
            itemtext.color = Bluemagic.PureColor;
            BluemagicWorld.AddText(itemtext, item.rare);
        }
        if(item.rare >= 13)
        {
            itemtext.color = new Color(Main.DiscoR, Main.DiscoG, Main.DiscoB);
            BluemagicWorld.AddText(itemtext, item.rare);
        }
    }

    public override bool PreDrawTooltipBuff(SpriteBatch sb, int buffIndex, int buffType, ref string text, ref bool imbue)
    {
        if(buffType == BuffDef.byName["Bluemagic:Ghoul"])
        {
            text += "(+" + (Main.localPlayer.GetSubClass<BluemagicPlayer>().numGhouls * 6) + " defense)";
        }
        return true;
    }
}}