using System;
using Terraria;
using TAPI;

namespace Bluemagic.Buffs {
public class Ghoul : ModBuff
{
    public override void Start(Player player, int index)
    {
        player.buffTime[index] = 3600;
    }

    public override void MidUpdate(Player player)
    {
        bool flag = false;
        for(int k = 0; k < 1000; k++)
        {
            if(Main.projectile[k].active && Main.projectile[k].owner == player.whoAmI && Main.projectile[k].type == ProjDef.byName["Bluemagic:Ghoul"].type)
            {
                flag = true;
                break;
            }
        }
        BluemagicPlayer modPlayer = player.GetSubClass<BluemagicPlayer>();
        if(flag)
        {
            modPlayer.ghoulMinion = true;
        }
        int type = BuffDef.byName["Bluemagic:Ghoul"];
        int index = -1;
        for(int k = 0; k < player.maxBuffs; k++)
        {
            if(player.buffType[k] == type)
            {
                index = k;
                break;
            }
        }
        if(index < 0)
        {
            return;
        }
        if(!modPlayer.ghoulMinion)
        {
            player.DelBuff(index);
        }
        else
        {
            player.buffTime[index] = 18000;
        }

        player.statDefense += 6 * modPlayer.numGhouls;
    }
}}