using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Buffs {
public class Transform : ModBuff
{
    private int defense = 0;
    public Transform(int d = 0)
    {
        defense = d;
    }

    public virtual void SetVars(Player player, BluemagicPlayer modPlayer) {}

    public override void Effects(Player player, int index)
    {
        BluemagicPlayer modPlayer = player.GetSubClass<BluemagicPlayer>();
        SetVars(player, modPlayer);
        player.wings = 0;
        player.accMerman = false;
        player.wolfAcc = false;
        player.noItems = true;
        player.noFallDmg = false;
    }

    public override void MidUpdate(Player player)
    {
        player.armorStealth = false;
        player.statDefense = defense;
        player.accDivingHelm = false;
        player.lifeRegen = 0;
        player.moveSpeed = 1f;
        player.boneArmor = false;
        player.frostArmor = false;
        player.rocketBoots = 0;
        player.fireWalk = false;
        player.knockbackResist = 1f;
        player.jumpBoost = false;
        player.noFallDmg = false;
        player.accFlipper = false;
        player.spaceGun = false;
        player.lavaImmune = false;
        player.gills = false;
        player.slowFall = false;
        player.thorns = 0f;
        player.waterWalk = false;
        player.waterWalk2 = false;
        player.bee = false;
        player.manaRegenBuff = false;
        player.shadowDodge = false;
        player.palladiumRegen = false;
        player.onHitDodge = false;
        player.onHitRegen = false;
        player.onHitPetal = false;
        player.iceBarrier = false;
        player.inferno = false;
        player.manaMagnet = false;
        player.lifeMagnet = false;
        player.beetleOrbs = 0;
        player.beetleBuff = false;
        player.magicCuffs = 0f;
        player.coldDash = false;
        player.magicQuiver = false;
        player.magmaStone = false;
        player.lavaRose = 1f;
        player.lavaRoseApplied = false;
        player.scope = false;
        player.panic = false;
        player.crystalLeafDelay = 0;
        player.moveSpeedMod = 1f;
        player.manaRegenBonus = 0;
        player.manaRegenDelayBonus = 0;
        player.carpet = false;
        player.iceSkate = false;
        player.dash = 0;
        player.spikedBoots = 0;
        player.blackBelt = false;
        player.lavaMax = 0;
        player.noItems = true;
        player.wereWolf = false;
        player.wings = 0;
        player.wingsLogic = 0;
        player.wingTimeMax = 0;
        player.starCloak = 0;
        player.longInvince = false;
        player.pStone = 1f;
        player.pStoneApplied = false;
        player.manaFlower = false;
        player.crimsonRegen = false;
        player.ghostHeal = false;
        player.ghostHurt = false;
        player.turtleArmor = false;
        player.spiderArmor = false;
        player.resistCold = false;
        player.ignoreWater = false;
        player.doubleJump2 = false;
        player.doubleJump3 = false;
        player.doubleJump4 = false;
        player.drawAfterimage = false;
        player.drawAura = false;
        player.drawGlow = false;
        player.autoJump = false;
        player.jumpSpeedBoost = 0f;
        player.extraFall = 0;
    }
}}