using System;
using Terraria;
using TAPI;

namespace Bluemagic.Items {
public class FoulOrb : ModItem
{
    public override bool CanUse(Player player)
    {
        if(!NPC.downedPlantBoss || player.position.Y < Main.hellLayer * 16)
        {
            return false;
        }
        for(int x = 0; x < 200; x++)
        {
            if(Main.npc[x].active && (Main.npc[x].type == NPCDef.byName["Bluemagic:Abomination"].type || Main.npc[x].type == NPCDef.byName["Bluemagic:CaptiveElement"].type || Main.npc[x].type == NPCDef.byName["Bluemagic:CaptiveElement2"].type))
            {
                return false;
            }
        }
        return true;
    }

    public override bool? UseItem(Player player)
    {
        BluemagicNet.PlaySound(15, (int)player.position.X, (int)player.position.Y, 0);
        if(Main.netMode == 1)
        {
            NetMessage.SendData(61, -1, -1, "", player.whoAmI, NPCDef.byName["Bluemagic:Abomination"].type, 0f, 0f, 0f);
        }
        else
        {
            NPC.SpawnOnPlayer(player.whoAmI, NPCDef.byName["Bluemagic:Abomination"].type);
        }
        return true;
    }
}}