using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Items {
public class RuneStaff : ModItem
{
    public override void PostItemCheck(Player p)
    {
        if(p.itemAnimation > 0)
        {
            float angle = p.itemRotation;
            if(p.direction == -1)
            {
                angle += (float)Math.PI;
            }
            Vector2 offset = 50f * new Vector2((float)Math.Cos(angle), (float)Math.Sin(angle));
            Vector2 location = p.Center + offset;
            Lighting.AddLight((int)(location.X / 16f), (int)(location.Y / 16f), 0.7f, 0f, 0f);
        }
    }
}}