using System;
using Terraria;
using TAPI;

namespace Bluemagic.Items {
public class MoltenBar : ModItem
{
    public override void MidUpdate(ref float gravity, ref float maxVelocity)
    {
        Lighting.AddLight((int)((item.position.X + (float)item.width*0.5f) / 16f), (int)((item.position.Y + (float)item.height*0.5f) / 16f), 0.7f, 0.4f, 0f);
    }

    public override void HoldStyle(Player p)
    {
        p.itemLocation.X = p.position.X + (float)p.width*0.5f + 6f*p.direction;
        p.itemLocation.Y = p.position.Y + (float)p.height*0.5f + 10f;
        if(p.gravDir == -1)
        {
            p.itemLocation.Y = p.position.Y + (float)p.height + (p.position.Y - p.itemLocation.Y);
        }
        p.itemRotation = 0;
    }

    public override bool SetHoldFrame(Player p)
    {
        p.bodyFrame.Y = p.bodyFrame.Height * 3;
        return true;
    }
}}