using System;
using Terraria;
using TAPI;

namespace Bluemagic.Items {
public class PaladinEmblem : ModItem
{
    public override bool CanUse(Player player)
    {
        if(!NPC.downedPlantBoss || !player.zoneDungeon)
        {
            return false;
        }
        for(int x = 0; x < 200; x++)
        {
            if(Main.npc[x].active && (Main.npc[x].type == NPCDef.byName["Bluemagic:PhantomSoul"].type || Main.npc[x].type == NPCDef.byName["Bluemagic:Phantom"].type))
            {
                return false;
            }
        }
        return true;
    }

    public override bool? UseItem(Player player)
    {
        if(Main.netMode != 1)
        {
            int npc = NPC.NewNPC((int)player.Center.X, (int)player.Center.Y, "Bluemagic:PhantomSoul", 0);
            Main.npc[npc].target = player.whoAmI;
            if(Main.netMode == 2)
            {
                BluemagicNet.SendNPCData(npc);
            }
        }
        BluemagicNet.NewClientText("You feel something cold leeching your life...", 50, 150, 200);
        return true;
    }
}}