using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Items {
public class PhantomBlade : ModItem
{
    public override bool PreShoot(Player player, Vector2 position, Vector2 velocity, int projType, int damage, float knockback)
    {
        int proj = Projectile.NewProjectile(position, velocity, projType, damage, knockback, player.whoAmI, 0f, 0f);
        Projectiles.DiagonalHitbox hitbox = Main.projectile[proj].GetSubClass<Projectiles.PhantomBlade>();
        hitbox.length = Main.projectileTexture[projType].Width;
        hitbox.width = Main.projectileTexture[projType].Height;
        if(Main.netMode != 0)
        {
            BluemagicNet.SendProjAllData(proj);
        }
        return false;
    }
}}