using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class FatGlobulet : ModProjectile
{
    public override void AI()
    {
        if(projectile.localAI[0] == 0f)
        {
            Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 3);
            projectile.localAI[0] = 1f;
        }
        if(Main.rand.Next(2) == 0)
        {
            Dust.NewDust(projectile.position, projectile.width, projectile.height, 4, (Main.rand.NextFloat() - 0.5f) * 4f, (Main.rand.NextFloat() - 1f) * 2f, 120, new Color(204, 194, 82), 1f);
        }
        projectile.rotation += 0.1f;
        if(projectile.rotation > 2f * (float)Math.PI)
        {
            projectile.rotation -= 2f * (float)Math.PI;
        }
    }
}}