using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class ForeignBall : ModProjectile
{
    public override void AI()
    {
        if(projectile.localAI[0] == 0f)
        {
            Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 20);
            projectile.localAI[0] = 1f;
        }
        if(projectile.ai[0] == 69f)
        {
            Lighting.AddLight((int)(projectile.Center.X + projectile.velocity.X) / 16, (int)(projectile.Center.Y + projectile.velocity.Y) / 16, 0.5f, 0.5f, 0.3f);
            projectile.frame = 0;
            projectile.displayName = "Ichor Ball";
        }
        else if(projectile.ai[0] == 39f)
        {
            Lighting.AddLight((int)(projectile.Center.X + projectile.velocity.X) / 16, (int)(projectile.Center.Y + projectile.velocity.Y) / 16, 0.3f, 0.5f, 0.3f);
            projectile.frame = 1;
            projectile.displayName = "Cursed Ball";
        }
        projectile.rotation += 0.5f;
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        p.AddBuff((int)projectile.ai[0], (int)projectile.ai[1], true);
    }
}}