using System;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class Needle : ModProjectile
{
    private int type = -1;

    public override bool PreAI()
    {
        type = projectile.type;
        projectile.type = 55;
        return true;
    }

    public override void PostAI()
    {
        projectile.type = type;
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(4) == 0)
        {
            p.AddBuff(70, 400, true);
        }
    }
}}