using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PhantomSphere : EllipseProj
{
    public override void AI()
    {
        for(int k = 0; k < 1000; k++)
        {
            if(k != projectile.whoAmI && Main.projectile[k].type == projectile.type && Main.projectile[k].timeLeft > projectile.timeLeft)
            {
                if(projectile.timeLeft > 120)
                {
                    projectile.timeLeft = 120;
                }
                break;
            }
        }
        projectile.Center = Main.player[projectile.owner].Center;
        if(projectile.timeLeft >= 450)
        {
            projectile.alpha = (int)((float)(projectile.timeLeft - 450) * 185f / 50f) + 70;
        }
        if(projectile.timeLeft < 100)
        {
            projectile.alpha = 255 - (int)((float)projectile.timeLeft * 185f / 100f);
        }
        for(int x = 0; x < 3; x++)
        {
            if(Main.rand.Next(30) == 0)
            {
                float angle = (float)Main.rand.Next(36) * 2f * (float)Math.PI / 36f;
                float xOff = (float)projectile.width * 0.5f * (float)Math.Cos(angle);
                float yOff = (float)projectile.width * 0.5f * (float)Math.Sin(angle);
                BluemagicDust.CreateSpectreDust(projectile.Center.X + xOff, projectile.Center.Y + yOff);
            }
        }
        Lighting.AddLight((int)((projectile.position.X + (float)projectile.width*0.5f) / 16f), (int)((projectile.position.Y + (float)projectile.height*0.5f) / 16f), 0.05f, 0.15f, 0.2f);
    }
}}