using System;
using Terraria;
using TAPI;

namespace Bluemagic.Tiles {
public class GoldenFishStatue : ModTileType
{
    public override void HitWire(int x, int y, int wireType)
    {
        Tile tile = Main.tile[x, y];
        int top = y - (int)(tile.frameY / 18);
        int left = x - (int)(tile.frameX / 18);
        Wiring.SkipWire(left, top);
        Wiring.SkipWire(left, top + 1);
        Wiring.SkipWire(left, top + 2);
        Wiring.SkipWire(left + 1, top);
        Wiring.SkipWire(left + 1, top + 1);
        Wiring.SkipWire(left + 1, top + 2);
        int spawnX = left * 16 + 16;
        int spawnY = (top + 3) * 16;
        if (Wiring.checkMech(x, y, 60) && Item.MechSpawn(spawnX, spawnY, 72) && Item.MechSpawn(spawnX, spawnY, 73) && Item.MechSpawn(spawnX, spawnY, 74))
        {
            int id = 72;
            if(Main.rand.Next(100) == 0)
            {
                id++;
                if(Main.rand.Next(100) == 0)
                {
                    id++;
                }
            }
            Item.NewItem(spawnX, spawnY - 20, 0, 0, id, 1, false, 0, false);
        }
    }
}}