using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.Tiles {
public class PuriumForge : ModTileType
{
    public override void ModifyLight(int x, int y, ref float r, ref float g, ref float b)
    {
        r = 0.83f;
        g = 0.6f;
        b = 0.5f;
    }

    public override void PostDrawType(SpriteBatch sb, bool solidTiles, int x, int y)
    {
        Tile tile = Main.tile[x, y];
        if(tile.frameX == 18 && tile.frameY == 18 && Main.rand.Next(40) == 0)
        {
            int dust = Dust.NewDust(new Vector2((float)(x * 16 - 4), (float)(y * 16 - 6)), 8, 6, 6, 0f, 0f, 100, default(Color), 1f);
            if(Main.rand.Next(3) != 0)
            {
                Main.dust[dust].noGravity = true;
            }
        }
    }
}}