using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Buffs {
public class Liquified : Transform
{
    public override void SetVars(Player player, BluemagicPlayer modPlayer)
    {
        if(modPlayer.liquified == 0)
        {
            modPlayer.liquified = 1 + Main.rand.Next(2);
        }
        else if(modPlayer.liquified < 0)
        {
            modPlayer.liquified *= -1;
        }
        if(player.width == Player.defaultWidth)
        {
            player.width = 32;
        }
        if(player.height == Player.defaultHeight)
        {
            player.height = 24;
            player.position.Y += Player.defaultHeight - player.height;
        }
    }
}}