using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class DarkFlames : ModProjectile
{
    public override void AI()
    {
        if(projectile.localAI[0] == 0f)
        {
            Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 20);
            projectile.localAI[0] = 1f;
        }
        if(Main.rand.Next(2) == 0)
        {
            BluemagicDust.CreateDFlameDust(projectile.position.X, projectile.position.Y, projectile.width, projectile.height, projectile.velocity * 0.5f);
        }
        projectile.rotation += 0.5f;
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(2) == 0)
        {
            p.AddBuff("Bluemagic:DarkFlames", 180, true);
        }
    }
}}