using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class MoltenDrill : ModProjectile
{
    public override void AI()
    {
        int dust = Dust.NewDust(projectile.position, projectile.width, projectile.height, 6, projectile.velocity.X * 0.2f, projectile.velocity.Y * 0.2f, 100, default(Color), 1.9f);
        Main.dust[dust].noGravity = true;
    }

    public override void DealtPVP(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(10) == 0)
        {
            p.AddBuff(24, 180, false);
        }
    }

    public override void DealtNPC(NPC npc, int hitDir, int dmgDealt, float knockback, bool crit)
    {
        if(Main.rand.Next(10) == 0)
        {
            npc.AddBuff(24, 180, false);
        }
    }
}}