using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PhantomOrb : EllipseProj
{
    public override void AI()
    {
        if(projectile.timeLeft == 450)
        {
            if(projectile.ai[0] == 0f)
            {
                projectile.velocity.X = 5f;
            }
            else if(projectile.ai[0] == 1f)
            {
                projectile.velocity.X = -5f;
            }
            else if(projectile.ai[0] == 2f)
            {
                projectile.velocity.Y = 5f;
            }
            else
            {
                projectile.velocity.Y = -5f;
            }
        }
    }

    public override bool PreDraw(SpriteBatch sb)
    {
        sb.Draw(Main.projectileTexture[projectile.type], projectile.position - Main.screenPosition, null, Color.White * ((255 - projectile.alpha) / 255f), projectile.rotation, Vector2.Zero, 1f, SpriteEffects.None, 0f);
        return false;
    }
}}