using System;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class MiniHammer : ModProjectile
{
    public override void OnSpawn()
    {
        float magnitude = (float)Math.Sqrt(projectile.velocity.X * projectile.velocity.X + projectile.velocity.Y * projectile.velocity.Y);
        projectile.velocity *= 10f / magnitude;
    }

    public override void AI()
    {
        if(projectile.velocity.X < 0f)
        {
            projectile.rotation -= 0.5f;
        }
        else
        {
            projectile.rotation += 0.5f;
        }
    }
}}