using System;
using Terraria;
using TAPI;

namespace Bluemagic.Tiles {
public class Banner : ModTileType
{
    public override void Kill(int x, int y, bool fail, bool effectsOnly, bool noItem)
    {
        if(!fail)
        {
            Tile tile = Main.tile[x, y];
            if(tile.frameY == 0)
            {
                int id = 0;
                int style = tile.frameX / 18;
                switch(style)
                {
                case 0:
                    id = Bluemagic.ItemID("SuspiciousSlimeBanner");
                    break;
                case 1:
                    id = Bluemagic.ItemID("TwinEyeBanner");
                    break;
                case 2:
                    id = Bluemagic.ItemID("FuryNightBanner");
                    break;
                case 3:
                    id = Bluemagic.ItemID("MechaSkeletonBanner");
                    break;
                case 4:
                    id = Bluemagic.ItemID("FallenZombieBanner");
                    break;
                case 5:
                    id = Bluemagic.ItemID("SentinelBanner");
                    break;
                case 6:
                    id = Bluemagic.ItemID("SarcophagusBanner");
                    break;
                case 7:
                    id = Bluemagic.ItemID("SandWormBanner");
                    break;
                case 8:
                    id = Bluemagic.ItemID("MotherScorpionBanner");
                    break;
                case 9:
                    id = Bluemagic.ItemID("OctopusBanner");
                    break;
                case 10:
                    id = Bluemagic.ItemID("PufferfishBanner");
                    break;
                case 11:
                    id = Bluemagic.ItemID("EelBanner");
                    break;
                case 12:
                    id = Bluemagic.ItemID("ShadowBanner");
                    break;
                case 13:
                    id = Bluemagic.ItemID("PuppetBanner");
                    break;
                case 14:
                    id = Bluemagic.ItemID("NightmareFuelBanner");
                    break;
                case 15:
                    id = Bluemagic.ItemID("RottingSpitterBanner");
                    break;
                case 16:
                    id = Bluemagic.ItemID("FleshySpitterBanner");
                    break;
                case 17:
                    id = Bluemagic.ItemID("BabyFeederBanner");
                    break;
                case 18:
                    id = Bluemagic.ItemID("FatGlobuleBanner");
                    break;
                case 19:
                    id = Bluemagic.ItemID("ForeignEntityBanner");
                    break;
                case 20:
                    id = Bluemagic.ItemID("DarkTotemBanner");
                    break;
                case 21:
                    id = Bluemagic.ItemID("SuspiciousCoelomBanner");
                    break;
                default:
                    break;
                }
                if(id > 0)
                {
                    Item.NewItem(x * 16, y * 16, 16, 48, id, 1, false, -1, false);
                }
            }
        }
    }
}}